<template>
  <div ref="picker" class="rui-rgba-picker" />
</template>

<script>
import Picker from 'vanilla-picker'

/**
 * Color picker.
 *
 * @bindValue 214,71,71,1
 * @disableProps modelValue
 */
export default {
  name: 'RuiRgbaPicker',
  emits: [
    'update:modelValue',
  ],
  props: {
    modelValue: { required: true, type: String },
  },
  data () {
    return {
      picker: null,
      pickerValue: null,
    }
  },
  methods: {
    convertStringToRGBA () { return this.$props.modelValue.split(',').map(v => Number(v.trim())) },
  },
  mounted () {
    this.picker = new Picker({
      parent: this.$refs.picker,
      popup: false,
      editor: false,
      color: this.convertStringToRGBA(),
      onChange: (v) => {
        const value = v.rgba.join(',')
        if (value === this.pickerValue) return
        this.pickerValue = value
        this.$emit('update:modelValue', value)
      },
    })
  },
  beforeUnmount () {
    this.picker.destroy()
  },
  watch: {
    modelValue (newValue) {
      // Avoid color reset with the same value: it leads to a reset of the picker
      if (newValue === this.pickerValue) return
      this.picker.setColor(this.convertStringToRGBA(), true)
    },
  },
}
</script>
